"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var xmlNode_1 = require("./xmlNode");
var xmlText_1 = require("./xmlText");
var XmlElement = /** @class */ (function (_super) {
    __extends(XmlElement, _super);
    function XmlElement(name) {
        var _this = _super.call(this) || this;
        _this.name = name;
        _this.children = [];
        return _this;
    }
    XmlElement.prototype.setName = function (name) {
        this.name = name;
        return this;
    };
    XmlElement.prototype.setAttributes = function (attributes) {
        this.attributes = attributes;
        return this;
    };
    XmlElement.prototype.appendElement = function (name, attributes, cb) {
        var el = new XmlElement(name).setAttributes(attributes);
        this.executeCallback(el, cb);
        this.children.push(el);
        return this;
    };
    XmlElement.prototype.appendText = function (content) {
        this.children.push(new xmlText_1.XmlText(content));
        return this;
    };
    XmlElement.prototype.eachLike = function (name, attributes, cb, options) {
        if (options === void 0) { options = { examples: 1 }; }
        var el = new XmlElement(name).setAttributes(attributes);
        this.executeCallback(el, cb);
        this.children.push({
            "pact:matcher:type": "type",
            value: el,
            examples: options.examples,
        });
        return this;
    };
    XmlElement.prototype.executeCallback = function (el, cb) {
        if (cb) {
            cb(el);
        }
    };
    return XmlElement;
}(xmlNode_1.XmlNode));
exports.XmlElement = XmlElement;
//# sourceMappingURL=xmlElement.js.map